/* Documentaion of the KEY module.  This file is not compiled. 
 */

/* A key as typed on a keyboard. 
 */

class Key
{
public:

	/* Modifiers
	 */
	enum {ctrl,  /* C-  */
	      meta}; /* M-  */

	/* Keys (only non printable keys have a name) 
	 */
	enum /* keys found on some keyboards */
	{
		no_key= 0,    
		ret,         
		up,          
		down,        
		left,        
		right,       
		home,        
		end,         
		tab,         
		escape,      
		backspace,   
		del,
	}

	Key(); 
	/* raw
	 */
	Key(int key);
	/* Without modifiers
	 */
	Key(int modifiers, int key);

	bool Is_Mod(int m) const;
	/* M is ctrl or meta */
	int Get_Key() const;
	bool Is_Print_Key() const;
	/* either a printable (char) or a constant */

	bool operator == (Key) const;

	static String Get_Name(int);
	/* Name of the key whithout modifiers.  Return the empty string of no name
	   is available. 
	*/
};
