#include "about_window.hh"

#include "version_number.hh"
#include "about_text.hh"
#include "license.hh"

bool
About_Window::Open(Pointer <Widget> parent,
		   Open_Info)
{
	if (V_Packer::Open(parent))
	{
		V_Packer::Set_Next_Resizeable(true); 
		if (clean_page.Open(this))
		{
			String text= "BabyChess Version " VERSION_NUMBER " " 
#ifndef NDEBUG
				"Debug "
#endif 
				"(" __DATE__ ").\n";
			clean_page.Append_Text(text);
			clean_page.Append_Text(ABOUT_TEXT);
		}

		bevel.Open(this);
		
		if (button_bar.Open(this))
		{
#if 0
			button_bar.Append
				(msg_license,
				 Trl("Read the license"));
#endif /* 0 */  
			button_bar.Append_OK_Button();
		}
		return true;
	}
	else
		return false;
}

#if 0

void
About_Window::MR_Receive(int msg)
{
	switch (id)
	{
	default:
		V_Packer::MR_Receive(msg);
		break;
#if 0
	case msg_license:
		License();
		break;
#endif /* 0 */ 
	}
}
#endif /* 0 */ 
