#ifndef ASSERT_FAILED_INCLUDED
#define ASSERT_FAILED_INCLUDED

/* Write message on standard error output and abort, pausing. 
 */ 

#ifndef NDEBUG

void Assert_Failed(const char *file_name,
		   int line,
		   const char *text, 
		   const char *function);
/* Report a failed assertion in FILE:LINE:FUNCTION.  TEXT describes the
   assertion.  Only defined if NDEBUG is not defined. 
 */

void Set_Assert_Hook(void (*)());
/* Register a function to be called on a failed assertion.  (E.g. to
   give up mouse grabs.) 
 */

#endif /* ! NDEBUG */

#endif /* ! ASSERT_FAILED_INCLUDED */
