#ifndef BOARD_SETTINGS_EDITOR_INCLUDED
#define BOARD_SETTINGS_EDITOR_INCLUDED

#include "board_settings.hh"
#include "board_settings_stream.hh"
#include "object_editor.hh"
#include "check_box.hh"
#include "trl.hh"
#include "color_chooser.hh"
#include "bevel.hh"

class Board_Settings_Editor
	:  public Object_Editor <Board_Settings> 
{
public:

	const Board_Settings &Editor_Window_Get_Value();

	const char *EW_Type_Name() const
		{
			return "Board preferences"; 
		}

private:

	Board_Settings settings;

	H_Packer main_packer;
	V_Packer left_packer, right_packer;
	Check_Box turned_check, frame_check, show_names_check,
		anti_alias_check; 
	Color_Chooser light_chooser, dark_chooser, last_move_chooser,
		frame_chooser; 
	Bevel bevel;

	bool Object_Editor_Open(Pointer <Widget> parent);
	int Editor_Window_Use();
	void Editor_Window_Set_Value(Pointer <const Board_Settings>);
	bool Editor_Window_New(); 
	void Wdg_Close();
	String Wdg_Init_Caption() const
		{
			return Trl("Board Preferences");
		}

	void Retrieve_Value();
};

#endif /* ! BOARD_INFO_EDITOR_INCLUDED */
