#include "board_settings_editor.hh"

#include "parse_stream.hh"

bool Read_Stream(Stream &stream, 
		 Board_Settings &settings)
{
	if (1 != Parse_Stream(stream, "%d ", & settings.flags))
		return false;
	for (int i= 0;  i < Board_Settings::color_count;  ++i)
	{
		if (3 != Parse_Stream(stream,
				      " %d %d %d",
				      & settings.colors[i].r,
				      & settings.colors[i].g,
				      & settings.colors[i].b))
			return false;
	}

	return true; 
}

bool Write_Stream(Stream &stream, 
		  const Board_Settings &settings)
{
	/* Don't save turnedness. 
	 */

	Dbg_Int(settings.flags);

	if (! Write_Formatted(stream,
			      "%d",
			      settings.flags & (~ bs_turned)))
		return false;
	for (int i= 0;  i < Board_Settings::color_count;  ++i)
	{
		if (! Write_Formatted(stream,
				      " %d %d %d",
				      settings.colors[i].r,
				      settings.colors[i].g,
				      settings.colors[i].b))
			return false;
	}

	Write_Formatted(stream, "\n");

	return true;
}

