#ifndef CHOICE_INCLUDED
#define CHOICE_INCLUDED

#include "pointer.hh"
#include "string.hh"

/* Choices are in the order of appearance in dialog windows. 
 */
enum {ch_yes    = (1 << 0),
      ch_no     = (1 << 1),
      ch_cancel = (1 << 2),

      ch_count= 3}; 

extern const char *const choice_text[3]; 

class Choice
	:  virtual public Pointed
{
public:

	Choice()
		{
		}
	Choice(String new_title,
	       String new_text,
	       int new_choices,
	       int new_selection)
		:  title (new_title),
		   text (new_text),
		   choices (new_choices),
		   selection (new_selection)
		{
		}

	String title;
	String text; 
	int choices;
	int selection;
};

#endif /* ! CHOICE_INCLUDED */
