#include "color_chooser.hh"

//#ifdef COLOR_CHOOSER_DEFAULT

#include "trl.hh"

bool
Color_Chooser::Open(Pointer <Widget> parent,
		    RGB new_color,
		    String text)
{
	if (! H_Packer::Open(parent))
		return false;

	color= new_color;

	Set_Next_Resizeable(true); 
	text_widget.Open(this, text + ":");
	color_display.Open(this, color);
	button.Open(this, msg_edit, Trl("Edit..."));

	return true; 
}

void
Color_Chooser::Wdg_Close()
{
  editor.Close();
}

void
Color_Chooser::MR_Receive(int id)
{
	switch (id)
	{
	case msg_edit:
		editor.Open(msg_edited, 
			     This,
			    RGB(color));
		break;

	case msg_edited:
	  color= editor.Get_Value();
		color_display.Set_Color(color);
		editor.Have_Read(); 
		break;
	}
}

void
Color_Chooser::Set_Color(RGB new_color)
{
	editor.Close(); 
	color= new_color; 
	color_display.Set_Color(new_color); 
}

//#endif /* COLOR_CHOOSER_DEFAULT */
