#ifndef COLOR_CHOOSER_INCLUDED
#define COLOR_CHOOSER_INCLUDED

#include "color_display.hh"
#include "owned_color_editor.hh"
#include "text_button.hh"
#include "packer.hh"
#include "text_widget.hh" 

class Color_Chooser
	:  public H_Packer
{
public:

	bool Open(Pointer <Widget>,
		  RGB,
		  String);

	RGB Get_Color() const
		{
			return color;
		}

	void Set_Color(RGB new_color); 

private:

	enum {msg_edit= H_Packer::msg_custom, msg_edited};

	RGB color;
	Text_Widget text_widget;
	Color_Display color_display;
	Text_Button button;

	Owned_Color_Editor editor; 

	void MR_Receive(int);

	void Wdg_Close();
};

#endif /* ! COLOR_CHOOSER_INCLUDED */
