#ifndef DEREF_INCLUDED
#define DEREF_INCLUDED

/* Dereferencing pointer, checking that they are not NULL. 

   Usage:

              Type *pointer= ...;
	      Deref(pointer)= ...;
 */

#include "assert.hh"
//#include "null.hh"
#include "inline.hh"

#include <stdlib.h>

template <class Type>
Inline
Type &
Deref(Type *pointer)
{
	Assert (pointer != NULL);
	return *pointer;
}

template <class Type>
Inline
const Type &
Deref(const Type *pointer)
{
	Assert (pointer != NULL);
	return *pointer;
}

#endif /* ! DEREF_INCLUDED */
