#include "dir.hh"

#include "deref.hh"
#include "dbg.hh"

#include <sys/stat.h>

bool
Dir::Open(String directory_name)
{
	Assert (! Is()); 
	Assert (directory_name.Is()); 

	dir= opendir(directory_name());
	return dir != NULL;
}

bool
Dir::Read(String &file_name)
{
	Assert(Is());

	struct dirent *dirent= readdir(dir);
	if (dirent == NULL)
		return false; 

	file_name= Deref(dirent).d_name;

	return true;
}

bool
Dir::Make(String directory_name)
{
  Dbg_Function();
  Dbg_Str(directory_name());
  int r= mkdir(directory_name(), 0777);   
	/* UMASK is substracted. 
	 */
  Dbg_Int(r);
  if (r >= 0)
    return true;
  else
    {
      Dbg_Str(strerror(errno));
    return false;
  }
}

