/* See `doc/dir.hh' for documentation of this module. 
 */

#ifndef DIR_INCLUDED
#define DIR_INCLUDED

#include "string.hh"

#include <dirent.h> /* DIR */

class Dir
{
public:

	Dir()
		:  dir (NULL) 
		{
		}
	Dir(String directory_name) 
		:  dir (NULL)
		{
			Open(directory_name); 
		}
	bool Is() const 
		{
			return dir != NULL; 
		} 
	void Close()
		{
			Assert(Is());  
			closedir(dir);  
			dir= NULL; 
		} 
	~Dir()
		{
			if (Is())
				Close(); 
		}

	bool Open(String directory_name);

	bool Read(String &);

	static bool Make(String);

private:

	DIR *dir;
	/* NULL when closed, else open. 
	 */
};

#endif /* ! DIR_INCLUDED */
