#ifndef EVALUATOR_SETTINGS_INCLUDED
#define EVALUATOR_SETTINGS_INCLUDED

#include "pointer.hh"
#include "string.hh"

class Evaluator_Settings
	:  public Pointed
{
public:

	enum Timing {ti_infinite= 0, ti_time};

	Timing timing;
	int time_s;
	String engine;
	/* If empty, own evaluator, else file name of XBoard engine. 
	 */
	bool parallel; 
	bool nice; 
	bool auto_reply; 

	Evaluator_Settings()
		{
			Reset(); 
		}

	Evaluator_Settings(Timing new_timing,
			   int new_time_s,
			   bool new_parallel= false,
			   bool new_nice= true)
		:  timing(new_timing),
		   time_s(new_time_s),
		   parallel(new_parallel),
		   nice(new_nice)
		{
		}

	void Reset();
};

#endif /* ! EVALUATOR_SETTINGS_INCLUDED */
