#ifndef EVALUATOR_SETTINGS_EDITOR_INCLUDED
#define EVALUATOR_SETTINGS_EDITOR_INCLUDED

#include "evaluator_settings.hh"
#include "object_editor.hh"
#include "int_edit.hh"
#include "radio_chooser.hh"
#include "trl.hh"
#include "edit.hh"
#include "check_box.hh"
#include "text_widget.hh"

class Evaluator_Settings_Editor
	:  public Object_Editor <Evaluator_Settings> 
{
public:

	const Evaluator_Settings &Editor_Window_Get_Value();

private:

        Radio_Chooser chooser;
	H_Packer time_packer;
	Text_Widget time_label, time_unit;
	Int_Edit time_s;
	Evaluator_Settings settings;
	Check_Box nice_check_box, auto_reply_check_box;

	bool Object_Editor_Open(Pointer <Widget> parent); 

	void Editor_Window_Set_Value(Pointer <const Evaluator_Settings> value)
		{
			if (value.Is())
				settings= value();
			else
				settings.Reset();
		}
	String Wdg_Init_Caption() const
		{
			return Trl("Engine Preferences");
		}
	void Wdg_Close()
		{
			Make_Result();
			Object_Editor <Evaluator_Settings> ::
				Wdg_Close();
		}
	void Make_Result();
};

#endif /* ! EVALUATOR_SETTINGS_EDITOR_INCLUDED */
