#ifndef EVALUATOR_WIDGET_INCLUDED
#define EVALUATOR_WIDGET_INCLUDED

#include "grid_packer.hh"
#include "text_widget.hh"
#include "framed.hh"
//#include "stabilized.hh"
#include "position.hh"
#include "generator.hh"
#include "menued.hh"
#include "evaluator_settings_editor.hh"
#include "owned_editor.hh"
#include "evaluator.hh"
#include "format_intmax.hh"
#include "format.hh"
#include "busy.hh"

class Evaluator_Widget
	:  public Framed <Grid_Packer> ,
	   public Menued ,
	   public Evaluator
{
public:

	enum {menu_main,

	      msg_run= Framed <Grid_Packer> ::msg_custom,
	      msg_pause, msg_terminate, msg_restart,
	      msg_change_auto_reply,
	      msg_change_infinite, 
	      msg_settings, msg_settings_edited, 
	      msg_custom, 
	};

	void MR_Receive(int);
	void Menued_Get(int menu, Menued::Entries &entries);

	bool Open(Pointer <Widget> parent, 
		  int msg_play, /* sent when should restart thinking */ 
		  int msg_changed, /* status change (running, finished...) */ 
		  int msg_play_best, 
		  /* Will be sent on the command "play best move". */
		  const Position &);

private:

	enum {count= 9};

	Text_Widget text_widgets[2][count];
	Text_Widget busy_text; 
	Busy busy;

	Owned_Editor <Evaluator_Settings_Editor> settings_editor;
	int msg_play, msg_changed;
	int msg_play_best;

	void Wdg_Close();

	void Clear_Info();

	void EC_Terminate(bool really, bool);

	void EC_Timer(int, int);
	void EC_Run();
	void EC_Pause();
	void EC_Depth(int depth);
	void EC_Main(int move);
	void EC_Score(int score);
	void EC_Knots(intmax_t knots); 
};

#endif /* ! EVALUATOR_WIDGET_INCLUDED */
