#include "file_name.hh"

#include "get_home.hh"
#include "resolve_path.hh"
#include "assert.hh"

String 
Base_Name(String file_name)
{
	if (! file_name.Is())
		return "";

	int last_slash= 0;
	for (int i= 0;  i + 1 < *file_name;  ++i)
	{
		if (file_name[i] == '/')
			last_slash= i;
	}

	if (file_name[last_slash] == '/')
		++ last_slash;
	return file_name.Sub(last_slash, *file_name - last_slash);
}

String
File_Name_In_Dir(String directory_name, 
		 String file_name)
{
	/* If FILE_NAME is absolute, return it. 
	 */
	if (file_name[0] == '/')
		return file_name;

	/* If DIRECTORY_NAME is empty, return FILE_NAME. 
	 */
	if (*directory_name == 0)
		return file_name;

	/* If DIRECTORY_NAME does not end in '/', add it. 
	 */
	if (directory_name[-1] != '/')
		directory_name += '/';

	return directory_name + file_name;
}

String
Path_Name(String name)
{
	return Resolve_Path(name / "..");
}

String Sub_Dir(int n)
{
	Assert (n >= 0);

	if (n == 0)
		return ".";
	String r= "..";
	while (true)
	{
		-- n;
		if (n == 0)
			return r;
		r += "/..";
	}
	return ".";
}
