#include "game_info.hh"

const char *Game_Info::result_text[4]=
{"1-0",
 "1/2-1/2",
 "0-1",
 "*"};

void
Game_Info::Set(const Hash_Table &all_tags)
{
	tags= all_tags; 

	tags.Remove("FEN"); 
	tags.Remove("SetUp"); 

	event= tags.Get("Event");
	tags.Remove("Event");
	if (event == '?')
		event= "";

	site= tags.Get("Site");
	tags.Remove("Site");
	if (site == '?')
		site= "";

	date= tags.Get("Date");
	tags.Remove("Date");
	if (date == '?')
		date= ""; 

	round= tags.Get("Round");
	tags.Remove("Round");
	if (round == '?')
		round= "";

	white= tags.Get("White");
	tags.Remove("White");
	if (white == '?')
		white= ""; 

	black= tags.Get("Black");
	tags.Remove("Black");
	if (black == '?')
		black= "";  
			
	String new_result= tags.Get("Result");
	tags.Remove("Result");
			
	if (new_result == "1-0")
		result= re_white;
	else if (new_result == "0-1")
		result= re_black;
	else if (new_result == "1/2"  ||
		 new_result == "1/2-1/2")
		result= re_draw;
	else 
		result= re_unfinished; 
}

void Game_Info::Reset()
{
	/* Maintain parallel to RAW_PGN::Reset();
	 */

	event= site= round= white= black= ""; 
	result= re_unfinished; 
	tags.Free(); 

//	game_date= Get_Date(); 
	date= Format_Date(Get_Date(), "%Y.%m.%d");
//	date= Format_Date(Get_Date(), df_day);
}
