#ifndef GAME_INFO_EDITOR_INCLUDED
#define GAME_INFO_EDITOR_INCLUDED

#include "object_editor.hh"
#include "grid_packer.hh"
#include "edit.hh"
#include "game_info.hh"
#include "radio_chooser.hh"
#include "text_widget.hh"

class Game_Info_Editor
	:  public Object_Editor <Game_Info>
{
public:

	const Game_Info &Editor_Window_Get_Value(); 

	void Set_Result(Game_Info::Result);

private:

	Grid_Packer packer; 
	Text_Widget texts[6]; 
	Edit edits[6]; 
	Radio_Chooser chooser; 

	Game_Info game_info; 

	void Editor_Window_Set_Value(Pointer <const Game_Info> new_game_info); 
	bool Object_Editor_Open(Pointer <Widget> parent); 
	String Wdg_Init_Caption() const; 
	void Wdg_Close();
	void Retrieve_Value();
};

#endif /* ! GAME_INFO_EDITOR_INCLUDED */ 
