#ifndef ICS_ACCOUNT_EDITOR_INCLUDED
#define ICS_ACCOUNT_EDITOR_INCLUDED

#include "object_editor.hh"
#include "int_edit.hh"
#include "grid_packer.hh"
#include "edit.hh"
#include "ics_account.hh"
#include "text_widget.hh"
#include "trl.hh"

class ICS_Account_Editor
:   public Object_Editor <ICS_Account> 
{
public:

	const ICS_Account &Editor_Window_Get_Value() 
	{
		return ics_account;
	}

private:

	Grid_Packer packer;
	Text_Widget host_label, port_label, user_label, password_label; 
	Edit host_edit, user_edit, password_edit;
	Int_Edit port_edit;
	ICS_Account ics_account;

	bool Object_Editor_Open(Pointer <Widget> parent);

	int Editor_Window_Use()
	{
		return use_ok;
	}

	void Editor_Window_Set_Value(Pointer <const ICS_Account> value)
	{
		ics_account= value();
	}
	
	bool Editor_Window_Change_Value(const ICS_Account &) 
	{
		Assert_Unreached();
		return false;
	}

	String Wdg_Init_Caption() const 
	{
	  return Trl("ICS Account");
	}

	void Make_Value()
	  {
		ics_account.host= host_edit.Get_Text();
		ics_account.port= port_edit.Get_Value();
		ics_account.user= user_edit.Get_Text();
		ics_account.password= password_edit.Get_Text();

	  }
	void Wdg_Close()
	  {
	    Make_Value();
	    Object_Editor <ICS_Account> ::Wdg_Close(); 
	  }
};

#endif /* ! ICS_ACCOUNT_EDITOR_INCLUDED */
