#ifndef IMAGE_WIDGET_INCLUDED
#define IMAGE_WIDGET_INCLUDED

#include "widget.hh"
#include "server_image.hh"

class Image_Widget
	:  public Widget
{
public:

	class Open_Info
	{
	};

	bool Open(Pointer <Widget> parent)
		{
			if (! Widget::Open(parent))
				return false;
			Invalidate_Image();
			return true;
		}

//	void Wdg_Get_Dimension(int &, int &, Stretchness &,
//			       Stretchness &);
	void Wdg_Get_Size_Request(int &, int &, bool &);

	const Server_Image &Get_Image() const
		{
			return image;
		}

	void Set_Image(const Server_Image &server_image)
		{
			if (Widget::Is())
			{
				Invalidate();
				Invalidate_Size();
			}
			image.Free();
			if (! server_image.Is())
				return;
			if (! image.Create(server_image.Get_Size()))
				return;
			if (! image.Has_Canvas())
				return;
			if (! server_image.Has_Canvas())
				return;
			image().Draw_Canvas(server_image(),
					    server_image.Get_Size(),
					    server_image.Get_Size());
		}

protected:

	void Invalidate_Image();

private:

	Server_Image image;
	/* Can be changed by inheriting.  May be set even when Widget
	   is not open. 
	 */

	virtual void Image_Widget_Build(Server_Image & /* image */)
		/* Load something into IMAGE.
		 */
		{
		}
	virtual void Image_Widget_Get_Dimension(int &width,
						int &height)
		/* Dimension if IMAGE is cleared. 
		 */
		{
			width= height= 0;
		}

#if 0
	const char *Wdg_Get_Name() const 
		{
			return "Image"; 
		}
#endif /* 0 */ 
	String Wdg_Get_Info() const 
		{ 
			return image.Is() ? "loaded" : "not loaded";  
		}
	void Wdg_Draw(Canvas &);

};

#endif /* ! IMAGE_WIDGET_INCLUDED */
