#include "inform_window.hh"

#include "trl.hh"

bool Inform_Window::Open(Pointer <Widget> parent, Open_Info open_info)
{
	GtkWidget *dialog = gtk_dialog_new(), 
		*label, *okay_button; 
	if (dialog == NULL)
		return false;
	label = gtk_label_new (open_info.text());
	if (label == NULL)
	{
		gtk_widget_destroy(dialog);
		return false;
	}
	gtk_misc_set_padding(GTK_MISC(label), unit / 2, unit / 2); 
	okay_button = gtk_button_new_with_label(Trl("OK"));
	if (okay_button == NULL)
	{
		gtk_widget_destroy(dialog);
		gtk_widget_destroy(label);
		return false; 
	}
   
	/* Ensure that the dialog box is destroyed when the user clicks ok. */
   
	gtk_signal_connect (GTK_OBJECT (okay_button), "clicked",
			    GTK_SIGNAL_FUNC(& Signal_OK),
			    this);
	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->action_area),
			   okay_button);

	/* Add the label, and show everything we've added to the dialog. */

	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->vbox),
			   label);
	gtk_window_set_title(GTK_WINDOW(dialog), 
			     open_info.title());

	gtk_window_set_policy(GTK_WINDOW(dialog), FALSE, FALSE, TRUE); 
	gtk_widget_show_all(dialog); 
			
	if (! Widget::Open(parent, dialog, false))
	{
		gtk_widget_destroy(label);
		gtk_widget_destroy(okay_button);
		return false;
	}
	Window::Inc();
	return true;
}
