#include "io.hh"

//#include "parse.hh"

#include <stdio.h>

#ifndef IO_NDEBUG

#include "env.hh"
#include "format.hh"

IO::Main  IO::main;

FILE *stddbg= NULL;

IO::Main::Main()
{
	String env= Env::Get(IO_ENV);

#ifdef IO_DBG
	fprintf(stderr,
		"IO:  IO_ENV= %s.\n",
		env.Get_Non_NULL());
#endif
	
	if (! env.Is())
	{
		int fd= dup(2);
		Assert (fd >= 0);
		stddbg= fdopen(fd, "w");
		Assert (stddbg != NULL);
	}
	else
	{
		int fd;
		const char *p= env(); 
		(void)p;
		int s= sscanf(env(), "%d", &fd);
		Assert (s == 1);
		stddbg= fdopen(fd, "w");
		Assert (stddbg != NULL);
	}
}

#endif /* ! IO_NDEBUG */

Stream IO::in(stdin);
Stream IO::out(stdout);
Stream IO::err(stderr);

#ifndef IO_NDEBUG
Stream IO::dbg(stddbg);
#endif
