#ifndef MEM_INCLUDED
#define MEM_INCLUDED

/* See `doc/mem.hh' for documentation. 
 */

//#ifdef DOS
//#    include "dos_mem.hh"
//#else
//#    define MEM_DEFAULT

class Mem
{
public:

	static void *Alloc(int);
	static void *Re_Alloc(void *, int);
	static void  Free(void *);

private:

//#ifdef MEM_DBG

	static int count;
	/* Number of allocated blocks.  
	 */

//#endif /* MEM_DBG */

};

#ifdef NDEBUG

/* Inline version in non-debug mode. 
 */

#include "inline.hh"
//#include "null.hh"

#include <stdlib.h>

Inline
void *
Mem::Alloc(int size)
{
	return (size == 0 
		? NULL 
		: malloc(size)); 
}

Inline
void *
Mem::Re_Alloc(void *pointer, 
	      int size)
{
	if (size == 0)
	{
		free(pointer); 
		return NULL;
	}
	else 
	{
		return realloc(pointer, size); 
	}
}

Inline
void 
Mem::Free(void *pointer)
{
	/* free(NULL) does nothing. 
	 */
	free(pointer); 
}

#endif /* NDEBUG */

//#endif /* MEM_DEFAULT */

#endif /* ! MEM_INCLUDED */
