#ifndef MENU_ITEM_INCLUDED
#define MENU_ITEM_INCLUDED

#include "dynamic.hh" 
#include "widget.hh"
#include "menued.hh"

class Gtk_Popup_Menu; 

class Menu_Item
	:  public Widget
{
public:

	bool Open(Pointer <Widget> parent,
		  const Menued::Entry &entry); 

private:

	Dynamic <Gtk_Popup_Menu> popup_menu; 
	int id; 
	Pointer <Menued> menued; 

	static void Signal_Activate(GtkMenuItem *gtkmenuitem,
				    gpointer user_data)
		{
			Menu_Item &item= Deref((Menu_Item *)user_data);

			Assert (gtkmenuitem == GTK_MENU_ITEM(item.Get()));

			item.Activate(); 
		}

	void Activate(); 
	void Wdg_Close(); 
};

class Gtk_Popup_Menu
	:  public Widget
{
public:

	bool Open(Pointer <Widget> parent)
		{
			Assert (parent == NULL); 
			return Widget::Open(NULL, gtk_menu_new(), false); 
		}

	void Append(const Menued::Entries &entries);

	void Clear();

	~Gtk_Popup_Menu();

private:

	Vector <Dynamic <Menu_Item> > items; 

	void Wdg_Append_Child(Widget &widget)
		{
			gtk_menu_append(GTK_MENU(Get()),
					widget.Get()); 
		}
};

#endif /* ! MENU_ITEM_INCLUDED */ 
