#ifndef MOVE_NAME_INCLUDED
#define MOVE_NAME_INCLUDED

/* The name of a chess move. 
 */

#include "piece_type.hh"
#include "square.hh"
#include "int.hh"

class Move_Name
{
public:

	Move_Name() 
		/* Raw */ 
		{
		}
	Move_Name(Piece_Type new_piece_type, 
		  int new_capture, 
		  int new_from_file,
		  int new_from_rank,
		  int new_to_file, 
		  int new_to_rank,
		  int new_special, 
		  int new_precision, 
		  int new_check)
	  :  piece_type(new_piece_type), 
		capture(new_capture), 
		from_file(new_from_file), 
		from_rank(new_from_rank),
		to_file(new_to_file), 
		to_rank(new_to_rank),
		special(new_special), 
		precision(new_precision), 
		check(new_check)
		{
		}

//	union
//	{
//		struct
//		{
			unsigned piece_type      :3; 
			unsigned capture         :3; 
			/* Piece type of captured piece + 1 or 0 when not a capture.  
			 */
			unsigned from_file       :3;
			unsigned from_rank       :3;
			unsigned to_file         :3;
			unsigned to_rank         :3;
			unsigned special         :3; 
			/* 0: normal move
			   1: en passant
			   2: O-O
			   3: O-O-O
			   4..7: promotion piece type + 3 
			*/
			unsigned precision       :2;
			/* Additional information needed in the short notation for
			   ambigous moves. 

			   0: no additional information needed
			   1: show destination file
			   2: show destination rank
			   3: show both
			*/
			unsigned check           :2;
			/* 0= no check
			   1= check
			   2= stalemate
			   3= checkmate
			*/
//		      };
//		
//		uint32_t value;
//	};
};

#endif /* ! MOVE_NAME_INCLUDED */ 
