#ifndef MOVED_INCLUDED
#define MOVED_INCLUDED

#include "square.hh"
#include "inline.hh"

Inline
bool
Is_Move_Square(int square)
	/* Whether S is one of the squares a1, e1, h1, a8, e8 or h8. */ 
{
	Assert(square >= 0 && square < 120);
	int file= Square_File(square), rank= Square_Rank(square);
	return ((rank == sq_1 || rank == sq_8)
		&& (file == sq_a || file == sq_e || file == sq_h));
}

Inline
int Square_Move_Index(int square)
/* S must be one of a1, e1, h1, a8, e8 or h8.  Return s the index of
   this square. 
*/
{
	Assert(square == sq_a1 || square == sq_e1 || square == sq_h1
	       || square == sq_a8 || square == sq_e8 || square == sq_h8);
	if (square > 32)
		square -= 81;
	else
		square -= 20;
	return square / 3;
}

#endif /* ! MOVED_INCLUDED */
