#include "multi_edit.hh"

void Multi_Edit::Append_Text(String text)
{
	Assert (Is()); 

	Freeze();

	gtk_text_insert(GTK_TEXT(Get()),
			NULL,
			NULL, NULL,
			text(),
			*text);
}

bool Multi_Edit::Open(Pointer <Widget> parent,
		      String text,
		      bool editable)
{
	if (! Widget::Open(parent, gtk_text_new(NULL, NULL)))
		return false;

	pending= false;

	gtk_text_set_word_wrap(GTK_TEXT (Get()),
			       TRUE);

	gtk_text_set_editable
		(GTK_TEXT(Get()),  
		 editable ? TRUE : FALSE); 

	Append_Text(text);

	return true;
}

String
Multi_Edit::Get_Text() const
{
	Assert (Is()); 
	gchar *text= gtk_editable_get_chars(GTK_EDITABLE(Get()),
					    0, -1);
	String result(text);
	result.Isolate();
	g_free(text);
	return result; 
}

void Multi_Edit::Wdg_Get_Size_Request(int &width,
				      int &height,
				      bool &resizeable)
{
	width= 200;
	height= 150; 
	resizeable= true; 
}

void Multi_Edit::Freeze(bool new_scroll_end)
{
	scroll_end |= new_scroll_end;
	if (pending)
		return;
	pending= true;
	gtk_text_freeze(GTK_TEXT(Get()));
	MR_Send(msg_thaw);
}

void Multi_Edit::MR_Receive(int msg)
{
	if (msg == msg_thaw)
	{
		pending= false;
		gtk_text_thaw(GTK_TEXT(Get())); 
		if (scroll_end)
			gtk_text_insert(GTK_TEXT(Get()),
					NULL, NULL, NULL, " ", 1); 
	}
	else
		Widget::MR_Receive(msg);
}

void Multi_Edit::Scroll_End()
{
	int len= gtk_text_get_length(GTK_TEXT(Get()));
	gtk_text_set_point(GTK_TEXT(Get()), len); 
	scroll_end= true;
}
