#ifndef MULTI_EDIT_INCLUDED
#define MULTI_EDIT_INCLUDED

#include "string.hh"
#include "widget.hh"

class Multi_Edit
	:  /*virtual*/ public Widget 
{
public:

	struct Open_Info
	{
		String text;
		bool editable;

		Open_Info(//bool new_wide= true,
			  String new_text= "",
			  bool new_editable= false)
			:  //wide (new_wide),
			   text (new_text),
			   editable (new_editable)
			{
			}
	};

	bool Open(Pointer <Widget> parent,
//		  bool /* wide */ = true,
		  String text= "",
		  bool editable= false);
	bool Open(Pointer <Widget> parent,
		  Open_Info open_info)
		{
			return Open(parent, 
//				    open_info.wide,
				    open_info.text,
				    open_info.editable);
		}

	void Append_Text(String text);

	void Wdg_Get_Size_Request(int &width,
				  int &height,
				  bool &resizeable);

	void Scroll_End();

	void Clear()
		{
		  Freeze();
			gtk_editable_delete_text(
				GTK_EDITABLE(Get()),
				0, -1);
		}
	String Get_Text() const;
	void Set_Text(String text)
		{
			Clear();
			Append_Text(text); 
		}

      private:

	enum {msg_thaw= Widget::msg_custom, msg_custom};

	bool pending;
	bool scroll_end;

	void MR_Receive(int);

	void Freeze(bool scroll_end= false);
};

#endif /* ! MULTI_EDIT_INCLUDED */ 
