#include "opt_main.hh"

#include "arg_main.hh"
#include "deref.hh"
//#include "null.hh"

#include "opt_main.config.hh"

#include <stdlib.h>

#ifdef OPT_MAIN_STDLIB
#    include <stdlib.h>
#elif defined (OPT_MAIN_GETOPT)
#    include <getopt.h>
#endif

static bool opt_main_opt[0x100];
static const char *opt_main_arg_options[0x100];
static bool opt_main_arg[0x100];

int
Arg_Main(int argc,
	 char **argv)
{
	for (const char *p= opt_main_options;
	     Deref(p) != '\0';
	     ++p)
	{
		int index= p[0];
		Assert (index >= 0 && index < 0x100);
		opt_main_opt[index]= false;
		opt_main_arg_options[index]= NULL;
		if (p[1] == ':')
		{
			opt_main_arg[index]= true;
			++p;
		}
		else
			opt_main_arg[index]= false;
		if (p[1] == ':')
			++p;
	}

#if defined (OPT_MAIN_STDLIB) || defined (OPT_MAIN_GETOPT)

	int c;
	while ((c= getopt(argc, argv, opt_main_options)) != -1)
	{
		Assert (c >= 0 && c < 0x100);
		bool is_arg= opt_main_arg[c];
		if (is_arg)
		{
			opt_main_arg_options[c]= optarg;
		}
		else
		{
			opt_main_opt[c]= true;
		}
	}

	return Opt_Main(argc - optind, argv + optind);

#else /* no getopt() */

	return Opt_Main(argc, argv); 

#endif /* no getopt() */
}

bool
Get_Opt(int option)
{
	Assert (option >= 0 && option < 0x100);

	return opt_main_opt[option];
}

const char *
Get_Opt_Arg(int option)
{
	Assert (option >= 0 && option < 0x100);

	return opt_main_arg_options[option];
}


