#ifndef PROCESS_INCLUDED
#define PROCESS_INCLUDED

/* See `doc/process.hh' for documentation. 
 */

//#ifdef DJGPP
//#    include "djgpp_process.hh"
//#else
//#    define PROCESS_DEFAULT

/* If the environment variable $BABY_PROCESS_PAUSE is not empty, the
   child process calls pause() just after fork()ing, so a debugger can
   be attached to the sleeping child process.   
 */

/* Macro:  PROCESS_CREATE_WAIT:  Wait in the parent. 
 */

//#include "null.hh"
#include "vector.hh"
#include "string.hh"

#include <sys/types.h>

typedef pid_t Process;
#define PROCESS_NO ((pid_t) -1)

bool Process_Create(String,
		    const Vector <String> &,
		    bool,
		    Process * = NULL,
		    Pointer <Stream> = NULL,
		    Pointer <Stream> = NULL,
		    Pointer <Stream> = NULL,
		    bool= false);

void Process_Kill(Process);
bool Process_Wait(Process, int &);
bool Process_Scan(Process &, String);
bool Process_Exists(Process);
Process Process_Self();
String Process_Format(Process);
void Process_Pause(Process);
void Process_Resume(Process);

//#endif /* PROCESS_DEFAULT */

#endif /* ! PROCESS_INCLUDED */
