#ifndef RADIO_CHOOSER_CONTENT_INCLUDED
#define RADIO_CHOOSER_CONTENT_INCLUDED

#include "grid_packer.hh"
#include "text_utils.hh"
#include "checkable_widget.hh"
#include "format.hh"
#include "dynamic.hh"

class Radio_Chooser_Content
	:  public Grid_Packer
{
public:

	enum {msg_clicked= Grid_Packer::msg_custom}; 

	class Open_Info
	{
	public:

		int msg_changed;
		int columns;

		Open_Info(int new_msg_changed, 
			  int new_columns)
			:  msg_changed (new_msg_changed), 
  			   columns (new_columns) 
			{
			}
	};

	bool Open(Pointer <Widget> parent, Open_Info);
	bool Open(Pointer <Widget> parent, 
		  int new_msg_changed, 
		  int new_columns)
		{
			return Open(parent,
				    Open_Info(new_msg_changed,
					      new_columns)); 
		}
	bool Append(String text);
	/* Add a radio button with text only. 
	 */
	bool Append(Dynamic <Checkable_Widget> &widget);
	/* Any widget can be added.  WIDGET must not be NULL.  WIDGET
	   must have been opened with THIS as parent and Next_ID() as
	   ID.  WIDGET will be freed automatically. 
	*/
	int Next_ID()
		{
			return *buttons;
		}
	int Get_Selected() const
		/* -1 when no selection.
		 */
		{
			return selected;
		}

	void Set_Selected(int new_selected);

	void Clear();
	int Get_Count() const
		{
			return Get_Children_Count(); 
		}

private:

	int selected;
	/* Item selected or -1.
	 */

	int msg_changed;
	/* Sent on change.
	 */

	int columns;
	/* Number of colums. 
	 */

	Vector <Dynamic <Checkable_Widget> > buttons;

	void MR_Receive(int);
};

#endif /* ! RADIO_CHOOSER_CONTENT_INCLUDED */

