#ifndef RC_INCLUDED
#define RC_INCLUDED

/* Resource files in the home directory.
 */

#include "file_name.hh"
#include "inline.hh"
#include "dir.hh"
#include "stream_file.hh"
#include "get_home.hh"
#include "dbg.hh"
#include "file_test.hh"

#define RC_DIR_NAME   ".baby"

Inline
bool
RC_Make_Dir()
/* Make the Baby directory in the home directory. */ 
{
	if (File_Is_Dir(Get_Home() / RC_DIR_NAME))
		return true;
	return Dir::Make(Get_Home() / RC_DIR_NAME);
}

Inline
String 
RC_File_Name(String name)
{
	return Get_Home() / RC_DIR_NAME / name;
}

template <class Type>
Inline bool 
RC_Load(Type &info)
{
	Dbg_Function();
	if (! RC_Make_Dir())
	{
		Dbg("\tfailed to make dir.");
		return false; 
	}
	Dbg("\tmade directory.");
	bool result= Read_From_File(RC_File_Name(info.Get_RC_Name()), info);
	Dbg_Int(result);
	return result;
}

template <class T>
Inline bool
RC_Save(const T &info)
{
	Dbg_Function();
	if (! RC_Make_Dir())
	{
		Dbg("\tcouldn't make dir."); 
		return false; 
	}
	Dbg("\tmade dir.");
	bool result= Write_To_File(RC_File_Name(info.Get_RC_Name()), info);
	Dbg_Int(result);
	return result; 
}

#endif /* ! RC_INCLUDED */
