#include "score.hh"

#include "text_utils.hh"
#include "format.hh"
//#include "scan.hh"

#include <stdio.h>

String 
Format_Score(int score)
{
	if (score < score_not_win)
	{
		if (score > score_not_lose)
			return Format("%d", score);
		else
		{
			if (score >= score_almost_is_mate)
			{
				int n= (score - score_almost_is_mate) / 2;
				Assert (n >= 0 && n < 100);
				return Format("~#%d", n);
			}
			else
			{
				int n= (score - score_is_mate) / 2;
				Assert (n >= 0 && n < 100);
				return Format("%%%d", n);
			}
		}
	}
	else
	{
		if (score > score_almost_mate_in_1)
		{
			int n= (score_mate_in_1 - score) / 2 + 1;
			Assert (n >= 0 && n < 100);
			return Format("#%d", n);
		}
		else
		{
			int n= (score_almost_mate_in_1 - score) / 2 + 1;
			Assert (n >= 0 && n < 100);
			return Format("~#%d", n);
		}
	}
}

int Parse_Score(String text)
{
	int score;
	if (1 == sscanf(text(), "%d", & score))
	{
		return score;
	}
	else if (text[0] == '#')
	{
		if (1 == sscanf(text(1),
			      "%d",
			      & score))
			return Score_Mate_In(score);
		else
			return score_even; 
		
	}
	else if (text[0] == '%')
	{
		if (1 == sscanf(text(1),
			      "%d",
			      & score))
			return Score_Is_Mate_In(score);
		else
			return score_even; 
					
	}
	else
		return score_even; 
}
