#ifndef SERVER_IMAGE_INCLUDED
#define SERVER_IMAGE_INCLUDED

#include "canvas.hh"
#include "widget.hh"

#include <gdk/gdk.h>

class Server_Image
{
public:

	Server_Image()
		:  pixmap(NULL)
		{
		}
	bool Is() const
		{
			return pixmap != NULL; 
		}
	~Server_Image()
		{
			if (Is())
				Free(); 
		}


	Canvas &Get_Canvas() const
		{
			Assert (canvas.Is());
			return ((Server_Image *)this)->canvas; 
		}
	Canvas &operator () () const
		{
			return Get_Canvas(); 
		}


	Point Get_Size() const
		{
			return size; 
		}

	void Free();

	bool Create(Point new_size)
		{
			Assert (new_size.x > 0 && new_size.y > 0); 
			Assert (! Is()); 

			pixmap= gdk_pixmap_new(NULL,
					       new_size.x, new_size.y,
					       Widget::Get_Depth());
			if (pixmap == NULL)
				return false;
			gc= NULL; 
			size= new_size; 
			return true; 
		}

	bool Has_Canvas() const
		{
			Assert (Is()); 
			if (canvas.Is())
				return true;
			return ((Server_Image *)this)->Open_GC();
		}

private:

	GdkPixmap *pixmap;
	GdkGC     *gc;
	Canvas     canvas;
	Point      size;

	bool Open_GC();
};

#endif /* ! SERVER_IMAGE_INCLUDED */ 
