#include "simple_poll.hh"

#include "stream_set.hh"
#include "poll.hh"
#include "input_reader.hh"
#include "default_timer.hh"

Stream_Set simple_poll_stream_set;

int Register_Input(Input_Reader &ir)
{
	simple_poll_stream_set.Insert(ir.Get_Stream());
	return 0; 
}

void Unregister_Input(Input_Reader &ir)
{
	simple_poll_stream_set.Remove(ir.Get_Stream());
}

void Simple_Poll()
{
	Stream_Set ready_stream_set= simple_poll_stream_set;

	int timer_index= -1;
	Date earliest= DATE_NO_DATE;
	Date now_date= Get_Date();
	
	for (int i= 0;  i < *timer_list;  ++i)
	{
		if (timer_list[i].Is())
		{
			Date date= timer_list[i]().content().last_alarm;
			date += ms_To_Date_Diff(timer_list[i]().content().interval);
			if (Date_Diff_ms(now_date, date) < 0)
			{
				timer_list[i]().content().last_alarm= Get_Date();
				timer_list[i]().Timer_Alarm();
				date= now_date;
				date += ms_To_Date_Diff(timer_list[i]().content().interval); 
			}
			if ((! Date_Is(earliest)) || (Date_Diff_ms(date, earliest) >= 0))
			{
				timer_index= i;
				earliest= date;
			}
		}
	}

	Time *poll_time= NULL;
	Time time;

	if (Date_Is(earliest))
	{
		int ms= Date_Diff_ms(Get_Date(), earliest);
		time= ms_To_Time(ms);
		poll_time= & time; 
	}

	if (! Poll(ready_stream_set, poll_time))
		return;

	if (poll_time != NULL)
	{
		if (Date_Diff_ms(earliest, Get_Date()) >= 0)
		{
			timer_list[timer_index]().content().last_alarm= Get_Date();
			timer_list[timer_index]().Timer_Alarm();
		}
	}

	for (int i= 0;  i < *Input_Reader::Get_List();  ++i)
	{
		if (Input_Reader::Get_List()[i].Is() &&
		    ready_stream_set.Ready(Input_Reader::Get_List()[i]().Get_Stream()))
			Input_Reader::Get_List()[i]().IR_Input(); 
	}
}
