#include "gui_main.hh"
#include "clock.hh"
#include "program_window.hh"
#include "packer.hh"
#include "text_widget.hh"
#include "check_box.hh"

class Main_Window
	:  public Program_Window,
	   public V_Packer 
{
public:  

  typedef Program_Window::Open_Info Open_Info; 

	bool Open(Pointer <Widget> parent,
		  Open_Info)
		{
			if (! V_Packer::Open(parent))
				return false;

			clock.Open(this); 
			text_widget.Open(this, "Gtk"); 
			check_box.Open(this, true, "Perl"); 

			return true;
		}


	static String Get_Help()
		{
			return "Clock.\n"; 
		}

private:

	Clock clock; 
	Text_Widget text_widget; 
	Check_Box check_box;
};

GUI_MAIN(Main_Window) 
