#include "text_radio_button.hh"

bool Text_Radio_Button::
Open(Pointer <Widget> parent,
     String text,
     int new_msg_changed,
     Pointer <Checkable_Widget> first)
{
	GtkWidget *w;

	if (first == NULL)
		w= gtk_radio_button_new_with_label
			(NULL,
			 text());
	else
		w= gtk_radio_button_new_with_label_from_widget
			(GTK_RADIO_BUTTON(first().Get()),
			 text());

	if (w == NULL)
		return false;

	if (! Widget::Open(parent, w))
		return false;

	gtk_signal_connect(GTK_OBJECT(Get()), 
			   "clicked",
			   GTK_SIGNAL_FUNC(Signal_Clicked), 
			   this);

	msg_changed= new_msg_changed; 

	return true;
}

void 
Text_Radio_Button::Signal_Clicked(GtkButton *gtkbutton,
				  gpointer *data)
{
	Text_Radio_Button *button= (Text_Radio_Button *)data;
	Assert (button != NULL);
	Assert (Deref(button).Get() ==
		GTK_WIDGET(gtkbutton));

	Deref(button).Parent_Send_Message(Deref(button).msg_changed); 
}

