#include "text_utils.hh"

#include <ctype.h>

bool Compare_Words(const char *s0, const char *s1)
{
	Assert(s0 && s1);

	while (!isspace(*s0) && *s0 && *s0==*s1)
	{++s0; ++s1; }

	return (isspace(*s0) || !*s0) && (isspace(*s1) || !*s1);
}

int Get_Next_Word(const char *c)
{
	Assert (c != NULL);
	const char *d= c;
	while (*d && !isspace(*d))
		++d;
	while (isspace(*d))
		++d;
	return d-c;
}

int Skip_Spaces(const char *c)
{
	Assert (c != NULL);
	const char *d= c;
	while (isspace(*d))
		++ d;
	return d - c;
}

int Skip_Word(const char *c)
{
	Assert (c != NULL);
	const char *d= c;
	while (*d != '\0' && ! isspace(*d))
		++ d;
	return d - c;
}

bool Contains_String(const char *c0, const char *c1)
	/* if c0 begins with c1. Both not NULL
   */
{
	Assert (c0 != NULL && c1 != NULL);

	while (*c1 != '\0' && *c0 == *c1)
	{++c0; ++c1; }

	return *c1 == '\0';
}
#if 0
String
Printify_Char(char c)
{
	if (isprint(c))
		return c;
  
	if (c == '\0')
		return "^@";

	if (c >= 1 && c <= 26)
		return (String('^')
			+ (char)('A' + c - 1));

	if (c == 27)
		return "^[";

	if (c == 28)
		return "^\\";

	if (c == 29)
		return "^]";

	if (c == 30)
		return "^^";

	if (c == 31)
		return "^_";

	return '?';
}
#endif /* 0 */ 
