#ifndef TEXT_WIDGET_INCLUDED
#define TEXT_WIDGET_INCLUDED

#include "widget.hh"
#include "display_type.hh"
#include "style.hh"
#include "alignment.hh"
#include "padding.hh"
#include "stretchness.hh"
#include "string.hh"

class Text_Widget
	:  /*virtual*/ public Widget
{
public:

	class Open_Info
	{
	public:
      
		String text;
		Display_Type display_type;
		Style style;
		Alignment alignment;

		Open_Info(String new_text= "",
			  Display_Type new_display_type= dt_default,
			  Style new_style= st_default,
			  Alignment new_alignment= al_default)
			:  text(new_text), 
			display_type(new_display_type),
			style(new_style),
			alignment(new_alignment)
			{
			}
	};

	bool Open(Pointer <Widget> parent,
		  String text= "",
		  Display_Type display_type= dt_default,
		  Style style= st_default,
		  Alignment alignment= al_begin)
		{
			Open_Info oi(text, display_type, style,
				     alignment);
			return Open(parent, oi);
		}

	bool Open(Pointer <Widget> parent,
		  const Open_Info &open_info);

	String Get_Text() const
		{
			gchar *text;
			gtk_label_get(GTK_LABEL(Get()), & text);
			String result(text);
			result.Isolate();
			return result; 
		}
  
	void Set_Text(String text)
		{
			gtk_label_set_text(GTK_LABEL(Get()), text()); 
		}
	void Set_Style(Style /* style */ )
		{
		}
};

#endif /* ! TEXT_WIDGET_INCLUDED */
