#ifndef TOOL_BAR_INCLUDED
#define TOOL_BAR_INCLUDED

#include "glyph_type.hh"
#include "widget.hh" 
#include "dynamic.hh"

class Tool_Bar
	:  /*virtual*/ public Widget
{
public: 

	bool Open(Pointer <Widget> parent)
		{
			return Widget::Open
				(parent,
				 gtk_toolbar_new
				 (GTK_ORIENTATION_HORIZONTAL,
				  GTK_TOOLBAR_TEXT));
		}

	void Append(Glyph_Type type,
		 int,
		 String tooltip= "");

	void Append_Space()
		{
			gtk_toolbar_append_space(GTK_TOOLBAR(Get()));
		}

private:

	class Callback
	{
	public:

		Pointer <Tool_Bar> tool_bar;
		int msg;

		Callback(Pointer <Tool_Bar> new_tool_bar,
			 int new_msg)
			:  tool_bar(new_tool_bar),
			   msg(new_msg)
			{
			}

		static gint Call(GtkWidget *, gpointer data);
	};

	Vector <Dynamic <Callback> > callbacks;
};

#endif /* ! TOOL_BAR_INCLUDED */ 
