#ifndef WINDOW_INCLUDED
#define WINDOW_INCLUDED

#include "gtk_object.hh"
#include "pointer.hh"
#include "string.hh"
#include "dbg.hh"

#include <gtk/gtk.h>

class Window
	:  public Gtk_Object 
{
public:

	Window();

	bool Open(String caption,
		  Point size= Point(-1)); 

	void Set(Gtk_Object &new_gtk_object)
		{
			Assert (Is());
			Assert (! gtk_object.Is());
			gtk_container_add(GTK_CONTAINER(Get()),
					  new_gtk_object.Get());
			gtk_object= new_gtk_object;
		}
	
	void Set_Caption(String text)
		{
			gtk_window_set_title(GTK_WINDOW(Get()),
					     text()); 
		}

//	void Set_Transient(const Window &window) const; 

	static void Loop()
		{
			int nc= count;
			nc= nc; 

			Assert (count >= 0); 

			if (count == 0)
				return; 
			in_loop= true;
			gtk_main();
			in_loop= false; 
		}

	static void Inc() 
		{
			++ count;
		}
	static void Dec()
		{
			Assert (count >= 1);
			-- count; 
			if (count == 0)
			{
				if (in_loop)
					gtk_main_quit();
			}
		}

private:

	Pointer <Gtk_Object> gtk_object;
	/* Content 
	 */

	static int count;
	/* Number of open windows.  
	 */
	static bool in_loop;

	void Wdg_Gtk_Delete(); 
	void Wdg_Destroy(); 
	bool Wdg_Close_Query()
	  {
	    Dbg_Function();
//	    return false;
	    return gtk_object().Wdg_Close_Query(); 
	  }
};

#endif /* ! WINDOW_INCLUDED */
