#ifndef XBOARD_ENGINE_SESSION_INCLUDED
#define XBOARD_ENGINE_SESSION_INCLUDED

#include "input_reader.hh"
#include "default_timer.hh"
#include "evaluator.hh"
#include "game.hh"

class XBoard_Engine_Session
	:  public Input_Reader,
	   public Evaluator
{
public:

	void Run();

private:

	Game game; 
	bool quit;
	bool post;

	virtual void IR_Input();
		/* Standard input.
		 */

	void Process_Input(String line); 

	void Stop(bool really= true)
		{
			Evaluator::Terminate(really);
		}

	void EC_Terminate(bool really, bool) ;

	void EC_Timer(int /* date_milliseconds */,
		      int /* time_milliseconds */)
		{
			Dbg("EC_Timer()");
		}
	void EC_Run()
		{
			Dbg("EC_Run()");
		}
	void EC_Pause()
		{
			Dbg("EC_Pause()");
		}
	void EC_Depth(int)
		{
			Dbg("EC_Depth()");
		}
	void EC_Main(int); 
};

#endif /* ! XBOARD_ENGINE_SESSION_INCLUDED */
